# Function Reference

[This is preliminary documentation and subject to change.]

Array Functions
File Functions
FileSet Functions
Windows Installer Functions
Windows Service Functions

### Array Functions

Name | Summary
--- | ---
array::reverse | Reverse the items in an array.
array::sort | Sorts the items in an array.

### File Functions

Name | Summary
--- | ---
file::get-checksum | Calculates a checksum for a given file and returns it in a hex string.

### FileSet Functions

Name | Summary
--- | ---
fileset::get-file-count | Determines the number of files within a <fileset>.
fileset::has-files | Determines whether <fileset> contains any files.
fileset::to-string | Returns a delimited string of all the filenames within a <fileset> with each filename separated by the specified delimiter string.

### Windows Installer Functions

Name | Summary
--- | ---
msi::get-product-code | Returns the product code of the specified Windows Installer database.
msi::is-installed | Returns a value indicating whether a product with the specified `product code` is installed.

### Windows Service Functions

Name | Summary
--- | ---
service::get-display-name | Gets the friendly name of the specified service.
service::get-service-name | Gets the name that identifies the specified service
service::get-status | Gets the status of the specified service.
service::is-installed | Returns a value indicating whether the specified service is installed on a given machine.
service::is-paused | Returns a value indicating whether the specified service is paused.
service::is-running | Returns a value indicating whether the specified service is running.
service::is-stopped | Returns a value indicating whether the specified service is stopped.